---
title: ServiceWorkerRegistration.pushManager
slug: Web/API/ServiceWorkerRegistration/pushManager
tags:
  - API
  - Property
  - Push
  - PushManager
  - Reference
  - Service Workers
  - ServiceWorkerRegistration
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <strong><code>pushManager</code></strong> property of the {{domxref("ServiceWorkerRegistration")}} interface returns a reference to the {{domxref("PushManager")}} interface for managing push subscriptions; this includes support for subscribing, getting an active subscription, and accessing push permission status.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>pushManager</em> = <em>serviceWorkerRegistration</em>.pushManager;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("PushManager")}} object.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">this.onpush = function(event) {
  console.log(event.data);
  // From here we can write the data to IndexedDB, send it to any open
  // windows, display a notification, etc.
}

navigator.serviceWorker.register('serviceworker.js').then(
  function(serviceWorkerRegistration) {
    serviceWorkerRegistration.pushManager.subscribe().then(
      function(pushSubscription) {
        console.log(pushSubscription.subscriptionId);
        console.log(pushSubscription.endpoint);
        // The push subscription details needed by the application
        // server are now available, and can be sent to it using,
        // for example, an XMLHttpRequest.
      }, function(error) {
        // During development it often helps to log errors to the
        // console. In a production environment it might make sense to
        // also report information about errors back to the
        // application server.
        console.log(error);
      }
    );
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Push API', '#pushmanager-interface', 'PushManager')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ServiceWorkerRegistration.pushManager")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Push_API">Push API</a></li>
</ul>
